from src.quick_yaml.data_structures import NestedDict
from src.quick_yaml.parser import QueryProcessor

sample_data = NestedDict(

    {

        "data": {'1': {'key1': 18,
                       'key2': 'B',
                       'time': '2022-03-29',
                       'type': 'Y',
                       'key3': {'subkey': 'value4'},
                       'key4': 136,
                       'key5': 29},
                 '2': {'key1': 23,
                       'key2': 'A',
                       'time': '2021-10-20',
                       'type': 'Z',
                       'key3': {'subkey': 'value3'},
                       'key4': 163,
                       'key5': 21},
                 '3': {'key1': 22,
                       'key2': 'C',
                       'time': '2020-06-01',
                       'type': 'X',
                       'key3': {'subkey': 'value6'},
                       'key4': 200,
                       'key5': 13},
                 '4': {'key1': 7,
                       'key2': 'D',
                       'time': '2023-04-21',
                       'type': 'Y',
                       'key3': {'subkey': 'value1'},
                       'key4': 66,
                       'key5': 12},
                 '5': {'key1': 14,
                       'key2': 'A',
                       'time': '2020-04-07',
                       'type': 'Y',
                       'key3': {'subkey': 'value2'},
                       'key4': 134,
                       'key5': 25},
                 '6': {'key1': 14,
                       'key2': 'B',
                       'time': '2020-04-30',
                       'type': 'Y',
                       'key3': {'subkey': 'value8'},
                       'key4': 92,
                       'key5': 10},
                 '7': {'key1': 6,
                       'key2': 'C',
                       'time': '2021-11-23',
                       'type': 'Z',
                       'key3': {'subkey': 'value3'},
                       'key4': 185,
                       'key5': 12},
                 '8': {'key1': 10,
                       'key2': 'B',
                       'time': '2022-09-22',
                       'type': 'Y',
                       'key3': {'subkey': 'value10'},
                       'key4': 62,
                       'key5': 29},
                 '9': {'key1': 19,
                       'key2': 'C',
                       'time': '2021-09-08',
                       'type': 'Z',
                       'key3': {'subkey': 'value3'},
                       'key4': 179,
                       'key5': 19},
                 '10': {'key1': 20,
                        'key2': 'C',
                        'time': '2021-06-03',
                        'type': 'Y',
                        'key3': {'subkey': 'value9'},
                        'key4': 88,
                        'key5': 11},
                 '11': {'key1': 24,
                        'key2': 'A',
                        'time': '2022-10-28',
                        'type': 'Y',
                        'key3': {'subkey': 'value1'},
                        'key4': 108,
                        'key5': 24},
                 '12': {'key1': 10,
                        'key2': 'B',
                        'time': '2022-01-30',
                        'type': 'Y',
                        'key3': {'subkey': 'value10'},
                        'key4': 173,
                        'key5': 28},
                 '13': {'key1': 19,
                        'key2': 'C',
                        'time': '2020-11-07',
                        'type': 'Y',
                        'key3': {'subkey': 'value9'},
                        'key4': 109,
                        'key5': 17},
                 '14': {'key1': 18,
                        'key2': 'B',
                        'time': '2020-03-24',
                        'type': 'Y',
                        'key3': {'subkey': 'value7'},
                        'key4': 164,
                        'key5': 11},
                 '15': {'key1': 12,
                        'key2': 'D',
                        'time': '2021-04-21',
                        'type': 'Y',
                        'key3': {'subkey': 'value8'},
                        'key4': 59,
                        'key5': 29},
                 '16': {'key1': 11,
                        'key2': 'A',
                        'time': '2022-11-14',
                        'type': 'Y',
                        'key3': {'subkey': 'value1'},
                        'key4': 121,
                        'key5': 27},
                 '17': {'key1': 7,
                        'key2': 'A',
                        'time': '2021-04-02',
                        'type': 'Y',
                        'key3': {'subkey': 'value4'},
                        'key4': 173,
                        'key5': 15},
                 '18': {'key1': 12,
                        'key2': 'D',
                        'time': '2021-01-14',
                        'type': 'X',
                        'key3': {'subkey': 'value5'},
                        'key4': 99,
                        'key5': 14},
                 '19': {'key1': 6,
                        'key2': 'C',
                        'time': '2022-05-27',
                        'type': 'Y',
                        'key3': {'subkey': 'value1'},
                        'key4': 62,
                        'key5': 21},
                 '20': {'key1': 20,
                        'key2': 'A',
                        'time': '2022-11-09',
                        'type': 'Y',
                        'key3': {'subkey': 'value9'},
                        'key4': 181,
                        'key5': 11},
                 '21': {'key1': 14,
                        'key2': 'D',
                        'time': '2022-04-03',
                        'type': 'Z',
                        'key3': {'subkey': 'value7'},
                        'key4': 88,
                        'key5': 15},
                 '22': {'key1': 13,
                        'key2': 'A',
                        'time': '2020-01-10',
                        'type': 'Y',
                        'key3': {'subkey': 'value4'},
                        'key4': 109,
                        'key5': 17},
                 '23': {'key1': 19,
                        'key2': 'C',
                        'time': '2020-05-20',
                        'type': 'X',
                        'key3': {'subkey': 'value6'},
                        'key4': 65,
                        'key5': 13},
                 '24': {'key1': 11,
                        'key2': 'A',
                        'time': '2020-04-17',
                        'type': 'Z',
                        'key3': {'subkey': 'value6'},
                        'key4': 106,
                        'key5': 28},
                 '25': {'key1': 22,
                        'key2': 'D',
                        'time': '2023-12-13',
                        'type': 'Y',
                        'key3': {'subkey': 'value9'},
                        'key4': 166,
                        'key5': 22},
                 '26': {'key1': 18,
                        'key2': 'C',
                        'time': '2020-04-17',
                        'type': 'Y',
                        'key3': {'subkey': 'value2'},
                        'key4': 198,
                        'key5': 17},
                 '27': {'key1': 23,
                        'key2': 'A',
                        'time': '2020-02-29',
                        'type': 'Y',
                        'key3': {'subkey': 'value10'},
                        'key4': 83,
                        'key5': 19},
                 '28': {'key1': 14,
                        'key2': 'D',
                        'time': '2020-01-25',
                        'type': 'X',
                        'key3': {'subkey': 'value4'},
                        'key4': 55,
                        'key5': 10},
                 '29': {'key1': 13,
                        'key2': 'A',
                        'time': '2023-04-25',
                        'type': 'X',
                        'key3': {'subkey': 'value9'},
                        'key4': 64,
                        'key5': 17},
                 '30': {'key1': 17,
                        'key2': 'A',
                        'time': '2021-03-02',
                        'type': 'Y',
                        'key3': {'subkey': 'value2'},
                        'key4': 96,
                        'key5': 27},
                 '31': {'key1': 9,
                        'key2': 'C',
                        'time': '2022-10-31',
                        'type': 'X',
                        'key3': {'subkey': 'value6'},
                        'key4': 157,
                        'key5': 13},
                 '32': {'key1': 23,
                        'key2': 'D',
                        'time': '2021-08-27',
                        'type': 'Z',
                        'key3': {'subkey': 'value6'},
                        'key4': 193,
                        'key5': 11},
                 '33': {'key1': 9,
                        'key2': 'C',
                        'time': '2023-05-05',
                        'type': 'Z',
                        'key3': {'subkey': 'value2'},
                        'key4': 81,
                        'key5': 16},
                 '34': {'key1': 13,
                        'key2': 'B',
                        'time': '2023-02-16',
                        'type': 'Z',
                        'key3': {'subkey': 'value3'},
                        'key4': 53,
                        'key5': 22},
                 '35': {'key1': 20,
                        'key2': 'C',
                        'time': '2020-05-26',
                        'type': 'Z',
                        'key3': {'subkey': 'value7'},
                        'key4': 106,
                        'key5': 17},
                 '36': {'key1': 9,
                        'key2': 'A',
                        'time': '2022-07-17',
                        'type': 'X',
                        'key3': {'subkey': 'value10'},
                        'key4': 190,
                        'key5': 29},
                 '37': {'key1': 13,
                        'key2': 'C',
                        'time': '2020-09-20',
                        'type': 'Y',
                        'key3': {'subkey': 'value5'},
                        'key4': 122,
                        'key5': 23},
                 '38': {'key1': 10,
                        'key2': 'B',
                        'time': '2023-01-02',
                        'type': 'Z',
                        'key3': {'subkey': 'value10'},
                        'key4': 61,
                        'key5': 20},
                 '39': {'key1': 20,
                        'key2': 'B',
                        'time': '2021-11-01',
                        'type': 'Z',
                        'key3': {'subkey': 'value5'},
                        'key4': 75,
                        'key5': 28},
                 '40': {'key1': 22,
                        'key2': 'B',
                        'time': '2020-04-09',
                        'type': 'X',
                        'key3': {'subkey': 'value3'},
                        'key4': 136,
                        'key5': 22},
                 '41': {'key1': 7,
                        'key2': 'A',
                        'time': '2023-01-11',
                        'type': 'X',
                        'key3': {'subkey': 'value7'},
                        'key4': 190,
                        'key5': 19},
                 '42': {'key1': 25,
                        'key2': 'B',
                        'time': '2022-12-10',
                        'type': 'X',
                        'key3': {'subkey': 'value7'},
                        'key4': 113,
                        'key5': 25},
                 '43': {'key1': 12,
                        'key2': 'D',
                        'time': '2022-12-03',
                        'type': 'X',
                        'key3': {'subkey': 'value10'},
                        'key4': 95,
                        'key5': 26},
                 '44': {'key1': 8,
                        'key2': 'C',
                        'time': '2020-05-12',
                        'type': 'X',
                        'key3': {'subkey': 'value10'},
                        'key4': 104,
                        'key5': 24},
                 '45': {'key1': 19,
                        'key2': 'C',
                        'time': '2020-12-18',
                        'type': 'Y',
                        'key3': {'subkey': 'value5'},
                        'key4': 99,
                        'key5': 16},
                 '46': {'key1': 12,
                        'key2': 'D',
                        'time': '2020-01-04',
                        'type': 'X',
                        'key3': {'subkey': 'value1'},
                        'key4': 183,
                        'key5': 15},
                 '47': {'key1': 19,
                        'key2': 'D',
                        'time': '2020-09-19',
                        'type': 'X',
                        'key3': {'subkey': 'value1'},
                        'key4': 175,
                        'key5': 22},
                 '48': {'key1': 9,
                        'key2': 'B',
                        'time': '2023-07-04',
                        'type': 'Y',
                        'key3': {'subkey': 'value7'},
                        'key4': 152,
                        'key5': 12},
                 '49': {'key1': 14,
                        'key2': 'A',
                        'time': '2020-03-30',
                        'type': 'X',
                        'key3': {'subkey': 'value10'},
                        'key4': 117,
                        'key5': 24},
                 '50': {'key1': 22,
                        'key2': 'B',
                        'time': '2021-10-16',
                        'type': 'Z',
                        'key3': {'subkey': 'value1'},
                        'key4': 137,
                        'key5': 13},
                 '51': {'key1': 10,
                        'key2': 'A',
                        'time': '2021-07-28',
                        'type': 'Z',
                        'key3': {'subkey': 'value4'},
                        'key4': 145,
                        'key5': 20},
                 '52': {'key1': 20,
                        'key2': 'C',
                        'time': '2022-07-06',
                        'type': 'Y',
                        'key3': {'subkey': 'value6'},
                        'key4': 80,
                        'key5': 22},
                 '53': {'key1': 19,
                        'key2': 'C',
                        'time': '2022-01-27',
                        'type': 'Z',
                        'key3': {'subkey': 'value3'},
                        'key4': 143,
                        'key5': 25},
                 '54': {'key1': 13,
                        'key2': 'C',
                        'time': '2021-07-25',
                        'type': 'X',
                        'key3': {'subkey': 'value7'},
                        'key4': 93,
                        'key5': 25},
                 '55': {'key1': 18,
                        'key2': 'A',
                        'time': '2020-01-08',
                        'type': 'Y',
                        'key3': {'subkey': 'value7'},
                        'key4': 109,
                        'key5': 29},
                 '56': {'key1': 16,
                        'key2': 'D',
                        'time': '2022-12-17',
                        'type': 'X',
                        'key3': {'subkey': 'value1'},
                        'key4': 60,
                        'key5': 13},
                 '57': {'key1': 9,
                        'key2': 'B',
                        'time': '2020-03-19',
                        'type': 'X',
                        'key3': {'subkey': 'value10'},
                        'key4': 80,
                        'key5': 19},
                 '58': {'key1': 12,
                        'key2': 'C',
                        'time': '2022-12-23',
                        'type': 'X',
                        'key3': {'subkey': 'value2'},
                        'key4': 164,
                        'key5': 25},
                 '59': {'key1': 23,
                        'key2': 'B',
                        'time': '2023-05-25',
                        'type': 'Y',
                        'key3': {'subkey': 'value4'},
                        'key4': 187,
                        'key5': 24},
                 '60': {'key1': 12,
                        'key2': 'B',
                        'time': '2023-12-15',
                        'type': 'Y',
                        'key3': {'subkey': 'value3'},
                        'key4': 131,
                        'key5': 18},
                 '61': {'key1': 11,
                        'key2': 'D',
                        'time': '2023-01-29',
                        'type': 'Z',
                        'key3': {'subkey': 'value8'},
                        'key4': 69,
                        'key5': 18},
                 '62': {'key1': 8,
                        'key2': 'B',
                        'time': '2022-11-27',
                        'type': 'X',
                        'key3': {'subkey': 'value6'},
                        'key4': 199,
                        'key5': 26},
                 '63': {'key1': 5,
                        'key2': 'C',
                        'time': '2022-08-24',
                        'type': 'X',
                        'key3': {'subkey': 'value6'},
                        'key4': 120,
                        'key5': 29},
                 '64': {'key1': 19,
                        'key2': 'C',
                        'time': '2021-05-21',
                        'type': 'X',
                        'key3': {'subkey': 'value7'},
                        'key4': 157,
                        'key5': 24},
                 '65': {'key1': 7,
                        'key2': 'D',
                        'time': '2022-11-03',
                        'type': 'Z',
                        'key3': {'subkey': 'value3'},
                        'key4': 140,
                        'key5': 13},
                 '66': {'key1': 21,
                        'key2': 'B',
                        'time': '2022-11-09',
                        'type': 'X',
                        'key3': {'subkey': 'value5'},
                        'key4': 148,
                        'key5': 16},
                 '67': {'key1': 20,
                        'key2': 'B',
                        'time': '2022-05-08',
                        'type': 'Y',
                        'key3': {'subkey': 'value7'},
                        'key4': 108,
                        'key5': 12},
                 '68': {'key1': 8,
                        'key2': 'D',
                        'time': '2022-12-25',
                        'type': 'Y',
                        'key3': {'subkey': 'value5'},
                        'key4': 99,
                        'key5': 15},
                 '69': {'key1': 15,
                        'key2': 'D',
                        'time': '2022-02-03',
                        'type': 'Y',
                        'key3': {'subkey': 'value2'},
                        'key4': 68,
                        'key5': 19},
                 '70': {'key1': 13,
                        'key2': 'D',
                        'time': '2023-10-14',
                        'type': 'Y',
                        'key3': {'subkey': 'value3'},
                        'key4': 112,
                        'key5': 21},
                 '71': {'key1': 8,
                        'key2': 'D',
                        'time': '2020-05-29',
                        'type': 'X',
                        'key3': {'subkey': 'value6'},
                        'key4': 56,
                        'key5': 25},
                 '72': {'key1': 25,
                        'key2': 'C',
                        'time': '2021-10-26',
                        'type': 'X',
                        'key3': {'subkey': 'value9'},
                        'key4': 145,
                        'key5': 16},
                 '73': {'key1': 15,
                        'key2': 'C',
                        'time': '2020-01-22',
                        'type': 'X',
                        'key3': {'subkey': 'value7'},
                        'key4': 130,
                        'key5': 18},
                 '74': {'key1': 20,
                        'key2': 'D',
                        'time': '2021-12-17',
                        'type': 'Y',
                        'key3': {'subkey': 'value2'},
                        'key4': 128,
                        'key5': 15},
                 '75': {'key1': 6,
                        'key2': 'D',
                        'time': '2022-02-26',
                        'type': 'Z',
                        'key3': {'subkey': 'value8'},
                        'key4': 145,
                        'key5': 29},
                 '76': {'key1': 10,
                        'key2': 'B',
                        'time': '2021-12-28',
                        'type': 'Z',
                        'key3': {'subkey': 'value7'},
                        'key4': 117,
                        'key5': 18},
                 '77': {'key1': 23,
                        'key2': 'C',
                        'time': '2021-07-18',
                        'type': 'X',
                        'key3': {'subkey': 'value4'},
                        'key4': 60,
                        'key5': 11},
                 '78': {'key1': 12,
                        'key2': 'B',
                        'time': '2022-01-23',
                        'type': 'Z',
                        'key3': {'subkey': 'value1'},
                        'key4': 101,
                        'key5': 17},
                 '79': {'key1': 11,
                        'key2': 'D',
                        'time': '2021-07-14',
                        'type': 'Y',
                        'key3': {'subkey': 'value3'},
                        'key4': 124,
                        'key5': 12},
                 '80': {'key1': 23,
                        'key2': 'D',
                        'time': '2021-03-29',
                        'type': 'Y',
                        'key3': {'subkey': 'value10'},
                        'key4': 66,
                        'key5': 17},
                 '81': {'key1': 7,
                        'key2': 'C',
                        'time': '2020-01-15',
                        'type': 'Z',
                        'key3': {'subkey': 'value3'},
                        'key4': 72,
                        'key5': 23},
                 '82': {'key1': 11,
                        'key2': 'C',
                        'time': '2023-07-08',
                        'type': 'Y',
                        'key3': {'subkey': 'value8'},
                        'key4': 70,
                        'key5': 13},
                 '83': {'key1': 15,
                        'key2': 'A',
                        'time': '2021-08-03',
                        'type': 'Y',
                        'key3': {'subkey': 'value3'},
                        'key4': 50,
                        'key5': 20},
                 '84': {'key1': 21,
                        'key2': 'B',
                        'time': '2020-03-13',
                        'type': 'Y',
                        'key3': {'subkey': 'value4'},
                        'key4': 54,
                        'key5': 20},
                 '85': {'key1': 20,
                        'key2': 'D',
                        'time': '2020-09-04',
                        'type': 'Y',
                        'key3': {'subkey': 'value4'},
                        'key4': 99,
                        'key5': 12},
                 '86': {'key1': 7,
                        'key2': 'C',
                        'time': '2020-08-31',
                        'type': 'Y',
                        'key3': {'subkey': 'value2'},
                        'key4': 147,
                        'key5': 29},
                 '87': {'key1': 8,
                        'key2': 'D',
                        'time': '2023-11-22',
                        'type': 'Y',
                        'key3': {'subkey': 'value5'},
                        'key4': 51,
                        'key5': 17},
                 '88': {'key1': 20,
                        'key2': 'A',
                        'time': '2022-11-09',
                        'type': 'X',
                        'key3': {'subkey': 'value8'},
                        'key4': 163,
                        'key5': 26},
                 '89': {'key1': 17,
                        'key2': 'B',
                        'time': '2023-11-02',
                        'type': 'Y',
                        'key3': {'subkey': 'value1'},
                        'key4': 141,
                        'key5': 22},
                 '90': {'key1': 24,
                        'key2': 'D',
                        'time': '2023-11-24',
                        'type': 'X',
                        'key3': {'subkey': 'value4'},
                        'key4': 167,
                        'key5': 19},
                 '91': {'key1': 10,
                        'key2': 'D',
                        'time': '2020-04-24',
                        'type': 'Z',
                        'key3': {'subkey': 'value7'},
                        'key4': 195,
                        'key5': 25},
                 '92': {'key1': 16,
                        'key2': 'D',
                        'time': '2021-08-09',
                        'type': 'Y',
                        'key3': {'subkey': 'value3'},
                        'key4': 96,
                        'key5': 28},
                 '93': {'key1': 13,
                        'key2': 'C',
                        'time': '2021-12-03',
                        'type': 'Z',
                        'key3': {'subkey': 'value9'},
                        'key4': 74,
                        'key5': 30},
                 '94': {'key1': 16,
                        'key2': 'D',
                        'time': '2021-10-06',
                        'type': 'X',
                        'key3': {'subkey': 'value10'},
                        'key4': 56,
                        'key5': 10},
                 '95': {'key1': 9,
                        'key2': 'D',
                        'time': '2022-11-28',
                        'type': 'Y',
                        'key3': {'subkey': 'value10'},
                        'key4': 62,
                        'key5': 26},
                 '96': {'key1': 8,
                        'key2': 'A',
                        'time': '2021-04-27',
                        'type': 'X',
                        'key3': {'subkey': 'value3'},
                        'key4': 168,
                        'key5': 16},
                 '97': {'key1': 23,
                        'key2': 'B',
                        'time': '2023-09-01',
                        'type': 'Y',
                        'key3': {'subkey': 'value2'},
                        'key4': 164,
                        'key5': 30},
                 '98': {'key1': 17,
                        'key2': 'D',
                        'time': '2021-09-02',
                        'type': 'Z',
                        'key3': {'subkey': 'value6'},
                        'key4': 116,
                        'key5': 19},
                 '99': {'key1': 6,
                        'key2': 'C',
                        'time': '2022-08-16',
                        'type': 'X',
                        'key3': {'subkey': 'value7'},
                        'key4': 199,
                        'key5': 28},
                 '100': {'key1': 8,
                         'key2': 'B',
                         'time': '2022-10-13',
                         'type': 'Z',
                         'key3': {'subkey': 'value3'},
                         'key4': 100,
                         'key5': 13}
                 }}
)
x = QueryProcessor(sample_data)
query = {
    "$filter": {
   "key4":{"$eq":181 },
        "key1": {"$eq": 20},

    },



}

x.process_query(query)

if type(x.results) is dict:
    for i, v in x.results.items():
        print(i)
        if isinstance(v, NestedDict):
            print(v.to_dict())
        if isinstance(v, list):
            for j in v:
                if isinstance(j, NestedDict):
                    print(j.to_dict())
                else:
                    print(j)
else:
    for i in x.results:
        print(i)